javax.swing.plaf.basic

## Class BasicTableUI

- java.lang.Object
- - javax.swing.plaf.ComponentUI
  - - javax.swing.plaf.TableUI
    - - javax.swing.plaf.basic.BasicTableUI

- Direct Known Subclasses:
    SynthTableUI

      public class BasicTableUI
      extends TableUI

  BasicTableUI implementation

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `class` | `BasicTableUI.FocusHandler` | This class should be treated as a "protected" inner class.
    `class` | `BasicTableUI.KeyHandler` | This class should be treated as a "protected" inner class.
    `class` | `BasicTableUI.MouseInputHandler` | This class should be treated as a "protected" inner class.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected FocusListener` | `focusListener` |
    `protected KeyListener` | `keyListener` |
    `protected MouseInputListener` | `mouseInputListener` |
    `protected CellRendererPane` | `rendererPane` |
    `protected JTable` | `table` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `BasicTableUI()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected FocusListener` | `createFocusListener()` | Creates the focus listener for handling keyboard navigation in the JTable.
    `protected KeyListener` | `createKeyListener()` | Creates the key listener for handling keyboard navigation in the JTable.
    `protected MouseInputListener` | `createMouseInputListener()` | Creates the mouse listener for the JTable.
    `static ComponentUI` | `createUI(JComponent c)` |
    `int` | `getBaseline(JComponent c, int width, int height)` | Returns the baseline.
    `Component.BaselineResizeBehavior` | `getBaselineResizeBehavior(JComponent c)` | Returns an enum indicating how the baseline of the component changes as the size changes.
    `Dimension` | `getMaximumSize(JComponent c)` | Return the maximum size of the table.
    `Dimension` | `getMinimumSize(JComponent c)` | Return the minimum size of the table.
    `Dimension` | `getPreferredSize(JComponent c)` | Return the preferred size of the table.
    `protected void` | `installDefaults()` | Initialize JTable properties, e.g.
    `protected void` | `installKeyboardActions()` | Register all keyboard actions on the JTable.
    `protected void` | `installListeners()` | Attaches listeners to the JTable.
    `void` | `installUI(JComponent c)` | Configures the specified component appropriately for the look and feel.
    `void` | `paint(Graphics g, JComponent c)` | Paint a representation of the `table` instance that was set in installUI().
    `protected void` | `uninstallDefaults()` |
    `protected void` | `uninstallKeyboardActions()` |
    `protected void` | `uninstallListeners()` |
    `void` | `uninstallUI(JComponent c)` | Reverses configuration which was done on the specified component during `installUI`.

    - ### Methods inherited from class javax.swing.plaf.ComponentUI

      `contains, getAccessibleChild, getAccessibleChildrenCount, update`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### table

          protected JTable table

    - #### rendererPane

          protected CellRendererPane rendererPane

    - #### keyListener

          protected KeyListener keyListener

    - #### focusListener

          protected FocusListener focusListener

    - #### mouseInputListener

          protected MouseInputListener mouseInputListener

  - ### Constructor Detail

    - #### BasicTableUI

          public BasicTableUI()

  - ### Method Detail

    - #### createKeyListener

          protected KeyListener createKeyListener()

      Creates the key listener for handling keyboard navigation in the JTable.

    - #### createFocusListener

          protected FocusListener createFocusListener()

      Creates the focus listener for handling keyboard navigation in the JTable.

    - #### createMouseInputListener

          protected MouseInputListener createMouseInputListener()

      Creates the mouse listener for the JTable.

    - #### createUI

          public static ComponentUI createUI(JComponent c)

    - #### installUI

          public void installUI(JComponent c)

      Description copied from class: `ComponentUI`
      Configures the specified component appropriately for the look and feel. This method is invoked when the `ComponentUI` instance is being installed as the UI delegate on the specified component. This method should completely configure the component for the look and feel, including the following:
      1. Install default property values for color, fonts, borders, icons, opacity, etc. on the component. Whenever possible, property values initialized by the client program should not be overridden.
      2. Install a `LayoutManager` on the component if necessary.
      3. Create/add any required sub-components to the component.
      4. Create/install event listeners on the component.
      5. Create/install a `PropertyChangeListener` on the component in order to detect and respond to component property changes appropriately.
      6. Install keyboard UI (mnemonics, traversal, etc.) on the component.
      7. Initialize any appropriate instance data.
      Overrides:
        `installUI` in class `ComponentUI`
      Parameters:
        `c` - the component where this UI delegate is being installed
      See Also:
        `ComponentUI.uninstallUI(javax.swing.JComponent)`, `JComponent.setUI(javax.swing.plaf.ComponentUI)`, `JComponent.updateUI()`

    - #### installDefaults

          protected void installDefaults()

      Initialize JTable properties, e.g. font, foreground, and background. The font, foreground, and background properties are only set if their current value is either null or a UIResource, other properties are set if the current value is null.
      See Also:
        `installUI(javax.swing.JComponent)`

    - #### installListeners

          protected void installListeners()

      Attaches listeners to the JTable.

    - #### installKeyboardActions

          protected void installKeyboardActions()

      Register all keyboard actions on the JTable.

    - #### uninstallUI

          public void uninstallUI(JComponent c)

      Description copied from class: `ComponentUI`
      Reverses configuration which was done on the specified component during `installUI`. This method is invoked when this `UIComponent` instance is being removed as the UI delegate for the specified component. This method should undo the configuration performed in `installUI`, being careful to leave the `JComponent` instance in a clean state (no extraneous listeners, look-and-feel-specific property objects, etc.). This should include the following:
      1. Remove any UI-set borders from the component.
      2. Remove any UI-set layout managers on the component.
      3. Remove any UI-added sub-components from the component.
      4. Remove any UI-added event/property listeners from the component.
      5. Remove any UI-installed keyboard UI from the component.
      6. Nullify any allocated instance data objects to allow for GC.
      Overrides:
        `uninstallUI` in class `ComponentUI`
      Parameters:
        `c` - the component from which this UI delegate is being removed; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `ComponentUI.installUI(javax.swing.JComponent)`, `JComponent.updateUI()`

    - #### uninstallDefaults

          protected void uninstallDefaults()

    - #### uninstallListeners

          protected void uninstallListeners()

    - #### uninstallKeyboardActions

          protected void uninstallKeyboardActions()

    - #### getBaseline

          public int getBaseline(JComponent c,
                                 int width,
                                 int height)

      Returns the baseline.
      Overrides:
        `getBaseline` in class `ComponentUI`
      Parameters:
        `c` - `JComponent` baseline is being requested for
        `width` - the width to get the baseline for
        `height` - the height to get the baseline for
      Returns:
        baseline or a value < 0 indicating there is no reasonable baseline
      Throws:
        `NullPointerException` - if `c` is `null`
        `IllegalArgumentException` - if width or height is < 0
      Since:
        1.6
      See Also:
        `JComponent.getBaseline(int, int)`

    - #### getBaselineResizeBehavior

          public Component.BaselineResizeBehavior getBaselineResizeBehavior(JComponent c)

      Returns an enum indicating how the baseline of the component changes as the size changes.
      Overrides:
        `getBaselineResizeBehavior` in class `ComponentUI`
      Parameters:
        `c` - `JComponent` to return baseline resize behavior for
      Returns:
        an enum indicating how the baseline changes as the component size changes
      Throws:
        `NullPointerException` - if `c` is `null`
      Since:
        1.6
      See Also:
        `JComponent.getBaseline(int, int)`

    - #### getMinimumSize

          public Dimension getMinimumSize(JComponent c)

      Return the minimum size of the table. The minimum height is the row height times the number of rows. The minimum width is the sum of the minimum widths of each column.
      Overrides:
        `getMinimumSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose minimum size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      Returns:
        a `Dimension` object or `null`
      See Also:
        `JComponent.getMinimumSize()`, `LayoutManager.minimumLayoutSize(java.awt.Container)`, `ComponentUI.getPreferredSize(javax.swing.JComponent)`

    - #### getPreferredSize

          public Dimension getPreferredSize(JComponent c)

      Return the preferred size of the table. The preferred height is the row height times the number of rows. The preferred width is the sum of the preferred widths of each column.
      Overrides:
        `getPreferredSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose preferred size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `JComponent.getPreferredSize()`, `LayoutManager.preferredLayoutSize(java.awt.Container)`

    - #### getMaximumSize

          public Dimension getMaximumSize(JComponent c)

      Return the maximum size of the table. The maximum height is the row heighttimes the number of rows. The maximum width is the sum of the maximum widths of each column.
      Overrides:
        `getMaximumSize` in class `ComponentUI`
      Parameters:
        `c` - the component whose maximum size is being queried; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      Returns:
        a `Dimension` object or `null`
      See Also:
        `JComponent.getMaximumSize()`, `LayoutManager2.maximumLayoutSize(java.awt.Container)`

    - #### paint

          public void paint(Graphics g,
                            JComponent c)

      Paint a representation of the `table` instance that was set in installUI().
      Overrides:
        `paint` in class `ComponentUI`
      Parameters:
        `g` - the `Graphics` context in which to paint
        `c` - the component being painted; this argument is often ignored, but might be used if the UI object is stateless and shared by multiple components
      See Also:
        `ComponentUI.update(java.awt.Graphics, javax.swing.JComponent)`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.